//+------------------------------------------------------------------+
//|                                         Duck_levels_dashboard.mq4 |
//|                                                     Tom Belada |
//|                                 http://www.theDstandsforDuck.com |
//+------------------------------------------------------------------+
#property copyright "Tom Belada"
#property link      "http://www.redtube.com"

#property indicator_chart_window
extern double STEP = 0.06;

/*double 
AUDCHF_, AUDCAD_, AUDNZD_, AUDGBP_, AUDJPY_, AUDUSD_, AUDEUR_,

CADAUD_, CADCHF_, CADEUR_, CADNZD_, CADGBP_, CADJPY_, CADUSD_,

CHFAUD_, CHFEUR_, CHFCAD_, CHFNZD_, CHFGBP_, CHFJPY_, CHFUSD_,

EURAUD_, EURCAD_, EURCHF_, EURNZD_, EURGBP_, EURJPY_, EURUSD_,

GBPAUD_, GBPCAD_, GBPCHF_, GBPEUR_, GBPNZD_, GBPJPY_, GBPUSD_,

JPYAUD_, JPYCHF_, JPYCAD_, JPYEUR_, JPYGBP_, JPYNZD_, JPYUSD_,

NZDAUD_, NZDCAD_, NZDEUR_, NZDCHF_, NZDJPY_, NZDGBP_, NZDUSD_,

USDAUD_, USDCAD_, USDCHF_, USDEUR_, USDGBP_, USDNZD_, USDJPY_  ;  */


string
      AUDCHF="AUDCHF",
      AUDCAD="AUDCAD",
      AUDNZD="AUDNZD",
      GBPAUD="GBPAUD",
      AUDJPY="AUDJPY",
      AUDUSD="AUDUSD",
      EURAUD="EURAUD",
      CADCHF="CADCHF",
      EURCAD="EURCAD",
      NZDCAD="NZDCAD",
      GBPCAD="GBPCAD",
      CADJPY="CADJPY",
      USDCAD="USDCAD",
      EURCHF="EURCHF",
      NZDCHF="NZDCHF",
      GBPCHF="GBPCHF",
      CHFJPY="CHFJPY",
      USDCHF="USDCHF",
      EURNZD="EURNZD",
      EURGBP="EURGBP",
      EURJPY="EURJPY",
      EURUSD="EURUSD",
      GBPNZD="GBPNZD",
      GBPJPY="GBPJPY",
      GBPUSD="GBPUSD",
      NZDJPY="NZDJPY",
      USDJPY="USDJPY",
      NZDUSD="NZDUSD";
      
      


string serazeni[56] = {"CHFAUD", "CADAUD", "NZDAUD", "GBPAUD", "EURAUD", "JPYAUD", "USDAUD", 
                       "AUDCAD", "CHFCAD", "EURCAD", "GBPCAD", "NZDCAD", "JPYCAD", "USDCAD", 
                       "AUDCHF", "CADCHF", "EURCHF", "GBPCHF", "NZDCHF", "JPYCHF", "USDCHF", 
                       "AUDEUR", "CADEUR", "CHFEUR", "GBPEUR", "NZDEUR", "JPYEUR", "USDEUR", 
                       "AUDGBP", "CADGBP", "CHFGBP", "EURGBP", "NZDGBP", "JPYGBP", "USDGBP", 
                       "AUDNZD", "CHFNZD", "CADNZD", "GBPNZD", "EURNZD", "JPYNZD", "USDNZD", 
                       "AUDJPY", "CHFJPY", "CADJPY", "GBPJPY", "EURJPY", "NZDJPY", "USDJPY", 
                       "AUDUSD", "CHFUSD", "CADUSD", "GBPUSD", "EURUSD", "NZDUSD", "JPYUSD"};
                 
                 
                 
//+------------------------------------------------------------------+
//| rovn na jednotlivch prech; index 0 = low                         |
//+------------------------------------------------------------------+

double 
AUDCHFLevels[20], AUDCADLevels[20], AUDNZDLevels[20], AUDGBPLevels[20], AUDJPYLevels[20], AUDUSDLevels[20], AUDEURLevels[20],

CADAUDLevels[20], CADCHFLevels[20], CADEURLevels[20], CADNZDLevels[20], CADGBPLevels[20], CADJPYLevels[20], CADUSDLevels[20],

CHFAUDLevels[20], CHFEURLevels[20], CHFCADLevels[20], CHFNZDLevels[20], CHFGBPLevels[20], CHFJPYLevels[20], CHFUSDLevels[20],

EURAUDLevels[20], EURCADLevels[20], EURCHFLevels[20], EURNZDLevels[20], EURGBPLevels[20], EURJPYLevels[20], EURUSDLevels[20],

GBPAUDLevels[20], GBPCADLevels[20], GBPCHFLevels[20], GBPEURLevels[20], GBPNZDLevels[20], GBPJPYLevels[20], GBPUSDLevels[20],

JPYAUDLevels[20], JPYCHFLevels[20], JPYCADLevels[20], JPYEURLevels[20], JPYGBPLevels[20], JPYNZDLevels[20], JPYUSDLevels[20],

NZDAUDLevels[20], NZDCADLevels[20], NZDEURLevels[20], NZDCHFLevels[20], NZDJPYLevels[20], NZDGBPLevels[20], NZDUSDLevels[20],

USDAUDLevels[20], USDCADLevels[20], USDCHFLevels[20], USDEURLevels[20], USDGBPLevels[20], USDNZDLevels[20], USDJPYLevels[20]  ;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- nate se nejvt low pro vechny pry (highlow)
//---- spote se 
//----
      initFirstLevels();
      setLevels();
      createAllLabels();

   return(0);
  }
  
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   
   string p1;
   string p11;
   string p111;

   
   for(int i = 0; i<56; i++){
     
        p1 = "D_"+serazeni[i];
        p11 = p1+"_level";
        p111 = p1+"_value";
        
        ObjectDelete(p1);
        ObjectDelete(p11);
        ObjectDelete(p111);
     
      
   }
//----
   return(0);
  }
  
  
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  // Print("posledni protnuty level na audchf je " + AUDCHFLevels[lastCrossed(AUDCHF, AUDCHFLevels, false)]);
  // Print("posledni protnuty level na jpyusd je " + JPYUSDLevels[lastCrossed(USDJPY, JPYUSDLevels, true)]);

 //     Print("low na usdjpy je"+ lLow("USDJPY"));
//   Print("druhy level na usdjpy je "+ USDJPYLevels[1]);
 //  Print("druhy level na jpyusd je "+ JPYUSDLevels[1]);


   
   
   run();
   
   
   
   



   int    counted_bars=IndicatorCounted();
   return(0);
  }
  
  
//+------------------------------------------------------------------+
//| Nalezen nej. high/low.                   |
//+------------------------------------------------------------------+
double hHigh(string pair)
   {
      double h;
      //h = iHigh(pair, PERIOD_MN1, iHighest(pair,PERIOD_MN1, MODE_HIGH,iBars(pair, PERIOD_MN1),0) );  
      h = iHigh(pair, PERIOD_W1, iHighest(pair,PERIOD_W1,MODE_HIGH,1000,0) );       
      //h= High[iHighest(pair,PERIOD_W1,MODE_HIGH,1000,0)];    
      return (h);
   }

double lLow(string pair)
   {
      double h;
      h = iLow (pair, PERIOD_W1, iLowest(pair,PERIOD_W1,MODE_LOW,1000,0) );
      //h= Low[iLowest(pair,PERIOD_W1,MODE_LOW,1000,0)];
      return (h);
   }
   
//+------------------------------------------------------------------+
//| spotan rovn po 600ti pipech          
//| param.: pole dan mny s natenm low na 0. indexu, high pru, je to jpy?         |
//+------------------------------------------------------------------+
void levels (double& pole[], double high, bool isJPY)
   {
      
      int i = 1;
      double step = STEP;
      if (isJPY){
       if(pole[0] < 1) step = step / 100; //uprava pro jpy pary
        else           step = step * 100;
       }
      
         while ((pole[i-1] < high) && (i<20)){
            pole[i] = pole[i-1] + step;
            i++;
         }
      
   } 
   
   
   

void setLevels ()
   {
   
     levels( AUDCHFLevels, MathPow(CHFAUDLevels[0], -1), false);
     levels( CHFAUDLevels, MathPow(AUDCHFLevels[0], -1), false);
     levels( AUDCADLevels, MathPow(CADAUDLevels[0], -1), false);
     levels( CADAUDLevels, MathPow(AUDCADLevels[0], -1), false);
     levels( AUDNZDLevels, MathPow(NZDAUDLevels[0], -1), false);
     levels( NZDAUDLevels, MathPow(AUDNZDLevels[0], -1), false);
     levels( GBPAUDLevels, MathPow(AUDGBPLevels[0], -1), false);
     levels( AUDGBPLevels, MathPow(GBPAUDLevels[0], -1), false);
     
     levels( AUDJPYLevels, MathPow(JPYAUDLevels[0], -1), true );
     levels( JPYAUDLevels, MathPow(AUDJPYLevels[0], -1), true );
     levels( AUDUSDLevels, MathPow(USDAUDLevels[0], -1), false);
     levels( USDAUDLevels, MathPow(AUDUSDLevels[0], -1), false);
     levels( EURAUDLevels, MathPow(AUDEURLevels[0], -1), false);
     levels( AUDEURLevels, MathPow(EURAUDLevels[0], -1), false);
      
     levels( CADCHFLevels, MathPow(CHFCADLevels[0], -1), false);
     levels( CHFCADLevels, MathPow(CADCHFLevels[0], -1), false);
     levels( EURCADLevels, MathPow(CADEURLevels[0], -1), false);
     levels( CADEURLevels, MathPow(EURCADLevels[0], -1), false);
     levels( NZDCADLevels, MathPow(CADNZDLevels[0], -1), false);
     levels( CADNZDLevels, MathPow(NZDCADLevels[0], -1), false);
     levels( GBPCADLevels, MathPow(CADGBPLevels[0], -1), false);
     levels( CADGBPLevels, MathPow(GBPCADLevels[0], -1), false);
     levels( CADJPYLevels, MathPow(JPYCADLevels[0], -1), true );
     levels( JPYCADLevels, MathPow(CADJPYLevels[0], -1), true );
     levels( USDCADLevels, MathPow(CADUSDLevels[0], -1), false);
     levels( CADUSDLevels, MathPow(USDCADLevels[0], -1), false);
      
     levels( EURCHFLevels, MathPow(CHFEURLevels[0], -1), false);
     levels( CHFEURLevels, MathPow(EURCHFLevels[0], -1), false);
     levels( NZDCHFLevels, MathPow(CHFNZDLevels[0], -1), false);
     levels( CHFNZDLevels, MathPow(NZDCHFLevels[0], -1), false);
     levels( GBPCHFLevels, MathPow(CHFGBPLevels[0], -1), false);
     levels( CHFGBPLevels, MathPow(GBPCHFLevels[0], -1), false);
     levels( CHFJPYLevels, MathPow(JPYCHFLevels[0], -1), true );
     levels( JPYCHFLevels, MathPow(CHFJPYLevels[0], -1), true );
     levels( USDCHFLevels, MathPow(CHFUSDLevels[0], -1), false);
     levels( CHFUSDLevels, MathPow(USDCHFLevels[0], -1), false);
      
     levels( EURNZDLevels, MathPow(NZDEURLevels[0], -1), false);
     levels( NZDEURLevels, MathPow(EURNZDLevels[0], -1), false);
     levels( EURGBPLevels, MathPow(GBPEURLevels[0], -1), false);
     levels( GBPEURLevels, MathPow(EURGBPLevels[0], -1), false);
     levels( EURJPYLevels, MathPow(JPYEURLevels[0], -1), true );
     levels( JPYEURLevels, MathPow(EURJPYLevels[0], -1), true );
     levels( EURUSDLevels, MathPow(USDEURLevels[0], -1), false);
     levels( USDEURLevels, MathPow(EURUSDLevels[0], -1), false);
       
     levels( GBPNZDLevels, MathPow(NZDGBPLevels[0], -1), false);
     levels( NZDGBPLevels, MathPow(GBPNZDLevels[0], -1), false);
     levels( GBPJPYLevels, MathPow(JPYGBPLevels[0], -1), true );
     levels( JPYGBPLevels, MathPow(GBPJPYLevels[0], -1), true );
     levels( GBPUSDLevels, MathPow(USDGBPLevels[0], -1), false);
     levels( USDGBPLevels, MathPow(GBPUSDLevels[0], -1), false);
     levels( NZDJPYLevels, MathPow(JPYNZDLevels[0], -1), true );
     levels( JPYNZDLevels, MathPow(NZDJPYLevels[0], -1), true );
     levels( USDJPYLevels, MathPow(JPYUSDLevels[0], -1), true );
     levels( JPYUSDLevels, MathPow(USDJPYLevels[0], -1), true );
     levels( NZDUSDLevels, MathPow(USDNZDLevels[0], -1), false);
     levels( USDNZDLevels, MathPow(NZDUSDLevels[0], -1), false);  
   
   
   } 
  
  
  
  
   
void initFirstLevels ()
   {
      AUDCHFLevels[0]=    lLow(AUDCHF);
      CHFAUDLevels[0]= MathPow(hHigh(AUDCHF), -1);
      AUDCADLevels[0]=    lLow(AUDCAD);
      CADAUDLevels[0]= MathPow(hHigh(AUDCAD), -1);
      AUDNZDLevels[0]=    lLow(AUDNZD);
      NZDAUDLevels[0]= MathPow(hHigh(AUDNZD), -1);
      GBPAUDLevels[0]=    lLow(GBPAUD);
      AUDGBPLevels[0]= MathPow(hHigh(GBPAUD), -1);
      AUDJPYLevels[0]=    lLow(AUDJPY);
      JPYAUDLevels[0]= MathPow(hHigh(AUDJPY), -1);
      AUDUSDLevels[0]=    lLow(AUDUSD);
      USDAUDLevels[0]= MathPow(hHigh(AUDUSD), -1);
      EURAUDLevels[0]=    lLow(EURAUD);
      AUDEURLevels[0]= MathPow(hHigh(EURAUD), -1);   
      
      CADCHFLevels[0]=    lLow(CADCHF);
      CHFCADLevels[0]= MathPow(hHigh(CADCHF), -1);
      EURCADLevels[0]=    lLow(EURCAD);
      CADEURLevels[0]= MathPow(hHigh(EURCAD), -1);
      NZDCADLevels[0]=    lLow(NZDCAD);
      CADNZDLevels[0]= MathPow(hHigh(NZDCAD), -1);
      GBPCADLevels[0]=    lLow(GBPCAD);
      CADGBPLevels[0]= MathPow(hHigh(GBPCAD), -1);
      CADJPYLevels[0]=    lLow(CADJPY);
      JPYCADLevels[0]= MathPow(hHigh(CADJPY), -1);
      USDCADLevels[0]=    lLow(USDCAD);
      CADUSDLevels[0]= MathPow(hHigh(USDCAD), -1);
      
      EURCHFLevels[0]=    lLow(EURCHF);
      CHFEURLevels[0]= MathPow(hHigh(EURCHF), -1);
      NZDCHFLevels[0]=    lLow(NZDCHF);
      CHFNZDLevels[0]= MathPow(hHigh(NZDCHF), -1);
      GBPCHFLevels[0]=    lLow(GBPCHF);
      CHFGBPLevels[0]= MathPow(hHigh(GBPCHF), -1);
      CHFJPYLevels[0]=    lLow(CHFJPY);
      JPYCHFLevels[0]= MathPow(hHigh(CHFJPY), -1);
      USDCHFLevels[0]=    lLow(USDCHF);
      CHFUSDLevels[0]= MathPow(hHigh(USDCHF), -1);
      
      EURNZDLevels[0]=    lLow(EURNZD);
      NZDEURLevels[0]= MathPow(hHigh(EURNZD), -1);
      EURGBPLevels[0]=    lLow(EURGBP);
      GBPEURLevels[0]= MathPow(hHigh(EURGBP), -1);
      EURJPYLevels[0]=    lLow(EURJPY);
      JPYEURLevels[0]= MathPow(hHigh(EURJPY), -1);
      EURUSDLevels[0]=    lLow(EURUSD);
      USDEURLevels[0]= MathPow(hHigh(EURUSD), -1);
      
      GBPNZDLevels[0]=    lLow(GBPNZD);
      NZDGBPLevels[0]= MathPow(hHigh(GBPNZD), -1);
      GBPJPYLevels[0]=    lLow(GBPJPY);
      JPYGBPLevels[0]= MathPow(hHigh(GBPJPY), -1);
      GBPUSDLevels[0]=    lLow(GBPUSD);
      USDGBPLevels[0]= MathPow(hHigh(GBPUSD), -1);
      NZDJPYLevels[0]=    lLow(NZDJPY);
      JPYNZDLevels[0]= MathPow(hHigh(NZDJPY), -1);
      USDJPYLevels[0]=    lLow(USDJPY);
      JPYUSDLevels[0]= MathPow(hHigh(USDJPY), -1);
      NZDUSDLevels[0]=    lLow(NZDUSD);
      USDNZDLevels[0]= MathPow(hHigh(NZDUSD), -1); 
      

   }
   
 // vrati index posledni dosazene urovne  
int lastCrossed (string pair, double pole[], double& var , bool inverted)
   {
      
      
      int vrchni, spodni;
      int index;
      var = MarketInfo(pair,MODE_BID);
      
      int i = 0, z=0;
      bool again = true;
      
      
      if (inverted) {var = MathPow(var, -1);}
      
      while (var > pole[i]){
         spodni = i;
         i++;
      }
     
      vrchni = spodni + 1;
      
  /*    y= 15;
      
      while (var < pole[y]){
         vrchni = y;
         Print("posledni vrchni je "+pole[y]);
         y--;
      }*/
      
      
      
      z= 0;
      
      double h,l,m;
      
      while(again) {
      
         h = iHigh(pair,PERIOD_H4,z);
         l = iLow(pair,PERIOD_H4,z);
         
         if(inverted){  
            m = l;            // v invertovanem se prohodi hi za low
            l = MathPow(h, -1);
            h = MathPow(m, -1);
         }
         if (( pole[vrchni]>=l ) && ( pole[vrchni]<=h )){
            index = vrchni;
            again = false;
            }
         if ((pole[spodni]>=l) && (pole[spodni]<=h)){
            index = spodni;
            again = false;
            }
         
         z++;
      }
      
    return (index);  
   
   
   }
   
void makeLable(string pair, int x, int y)
   {
       //  color barv;
        // if (clor) { barv = color_pair1;}
       //  else { barv = color_pair2;}
         
         string p1 = "D_"+pair;
         string p11 = p1+"_level";
         string p111 = p1+"_value";
         ObjectDelete(p1);
         ObjectCreate(p1, OBJ_LABEL, 0, 0, 0);
         ObjectSetText(p1, pair, 9, "Arial", LimeGreen);
         ObjectSet(p1, OBJPROP_CORNER, 0);
         ObjectSet(p1, OBJPROP_XDISTANCE, x);
         ObjectSet(p1, OBJPROP_YDISTANCE, y);
         
         ObjectDelete(p11);
         ObjectCreate(p11, OBJ_LABEL, 0, 0, 0);
         ObjectSetText(p11, "1.23456", 9, "Arial Bold", White);
         ObjectSet(p11, OBJPROP_CORNER, 0);
         ObjectSet(p11, OBJPROP_XDISTANCE, x+60);
         ObjectSet(p11, OBJPROP_YDISTANCE, y);  
         
         ObjectDelete(p111);
         ObjectCreate(p111, OBJ_LABEL, 0, 0, 0);
         ObjectSetText(p111,"600 pips", 9, "Arial Bold", Yellow);
         ObjectSet(p111, OBJPROP_CORNER, 0);
         ObjectSet(p111, OBJPROP_XDISTANCE, x +115);
         ObjectSet(p111, OBJPROP_YDISTANCE, y);     
   
      
      
   }

void createAllLabels()
   {
     // makeLable(AUDUSD, 10, 30);
     int p = 0;
     
     for (int z=0; z<=1; z++)
     {
      for(int i=1; i<=4; i++){
      
         for(int y=1; y<=7; y++){
            
            makeLable(serazeni[p], (i*190) - 180, (15*y)+(z*150));
            p++;
            
         }
       }
     }      
      
   }


void setLable (string pair, double level, double pips){
           
           string p1 = "D_"+pair;
           string p11 = p1+"_level";
           string p111 = p1+"_value";
           pips = pips *10000;
           string pi = DoubleToStr(pips,0) + " pips";
            
         ObjectSetText(p11, DoubleToStr(level,5), 9, "Arial Bold", White);
         ObjectSetText(p111, pi, 9, "Arial Bold", Yellow);

            
         }
         
void run (){
   
      double level;
      double price;
      
      level = AUDCHFLevels[lastCrossed(AUDCHF, AUDCHFLevels, price, false)];
      setLable(AUDCHF, level, price - level);
     
      
      level = CHFAUDLevels[lastCrossed(AUDCHF, CHFAUDLevels, price, true)];
      setLable("CHFAUD", level, price - level);

      
      
      level = AUDCADLevels[lastCrossed(AUDCAD, AUDCADLevels, price, false)];
      setLable(AUDCAD, level, price - level);
      
      
      level = CADAUDLevels[lastCrossed(AUDCAD, CADAUDLevels, price, true)];
      setLable("CADAUD", level, price - level);
      
      
      level = AUDNZDLevels[lastCrossed(AUDNZD, AUDNZDLevels, price, false)];
      setLable(AUDNZD, level, price - level);
      
      
      level = NZDAUDLevels[lastCrossed(AUDNZD, NZDAUDLevels, price, true)];
      setLable("NZDAUD", level, price - level);
      
      
      level = GBPAUDLevels[lastCrossed(GBPAUD, GBPAUDLevels, price, false)];
      setLable(GBPAUD, level, price - level);
      
      
      level = AUDGBPLevels[lastCrossed(GBPAUD, AUDGBPLevels, price, true)];
      setLable("AUDGBP", level, price - level);
      
      
      level = AUDJPYLevels[lastCrossed(AUDJPY, AUDJPYLevels, price, false)];
      setLable(AUDJPY, level/100, (price - level)/100);
      
      
      level = JPYAUDLevels[lastCrossed(AUDJPY, JPYAUDLevels, price, true)];
      setLable("JPYAUD", level*100, (price - level)*100);
      
      
      level = AUDUSDLevels[lastCrossed(AUDUSD, AUDUSDLevels, price, false)];
      setLable(AUDUSD, level, price - level);
      
      
      level = USDAUDLevels[lastCrossed(AUDUSD, USDAUDLevels, price, true)];
      setLable("USDAUD", level, price - level);
      
      
      level = EURAUDLevels[lastCrossed(EURAUD, EURAUDLevels, price, false)];
      setLable(EURAUD, level, price - level);
      
         
      level = AUDEURLevels[lastCrossed(EURAUD, AUDEURLevels, price, true)];
      setLable("AUDEUR", level, price - level);
      
      
      level = CADCHFLevels[lastCrossed(CADCHF, CADCHFLevels, price, false)];
      setLable(CADCHF, level, price - level);
      
     
      level = CHFCADLevels[lastCrossed(CADCHF, CHFCADLevels, price, true)];
      setLable("CHFCAD", level, price - level);
      
      
      level = EURCADLevels[lastCrossed(EURCAD, EURCADLevels, price, false)];
      setLable(EURCAD, level, price - level);
      
      
      level = CADEURLevels[lastCrossed(EURCAD, CADEURLevels, price, true)];
      setLable("CADEUR", level, price - level);
      
      
      level = NZDCADLevels[lastCrossed(NZDCAD, NZDCADLevels, price, false)];
      setLable(NZDCAD, level, price - level);
      
      
      level = CADNZDLevels[lastCrossed(NZDCAD, CADNZDLevels, price, true)];
      setLable("CADNZD", level, price - level);
      
      
      level = GBPCADLevels[lastCrossed(GBPCAD, GBPCADLevels, price, false)];
      setLable(GBPCAD, level, price - level);
      
      
      level = CADGBPLevels[lastCrossed(GBPCAD, CADGBPLevels, price, true)];
      setLable("CADGBP", level, price - level);
      
      
      level = CADJPYLevels[lastCrossed(CADJPY, CADJPYLevels, price, false)];
      setLable(CADJPY, level/100, (price - level)/100);
      
      
      level = JPYCADLevels[lastCrossed(CADJPY, JPYCADLevels, price, true)];
      setLable("JPYCAD", level*100, (price - level)*100);
      
      
      level = USDCADLevels[lastCrossed(USDCAD, USDCADLevels, price, false)];
      setLable(USDCAD, level, price - level);
      
      
      level = CADUSDLevels[lastCrossed(USDCAD, CADUSDLevels, price, true)];
      setLable("CADUSD", level, price - level);
      
      
      level = EURCHFLevels[lastCrossed(EURCHF, EURCHFLevels, price, false)];
      setLable(EURCHF, level, price - level);
      
      
      level = CHFEURLevels[lastCrossed(EURCHF, CHFEURLevels, price, true)];
      setLable("CHFEUR", level, price - level);
      
      
      level = NZDCHFLevels[lastCrossed(NZDCHF, NZDCHFLevels, price, false)];
      setLable(NZDCHF, level, price - level);
      
      
      level = CHFNZDLevels[lastCrossed(NZDCHF, CHFNZDLevels, price, true)];
      setLable("CHFNZD", level, price - level);
      
      
      level = GBPCHFLevels[lastCrossed(GBPCHF, GBPCHFLevels, price, false)];
      setLable(GBPCHF, level, price - level);
      
      
      level = CHFGBPLevels[lastCrossed(GBPCHF, CHFGBPLevels, price, true)];
      setLable("CHFGBP", level, price - level);
      
      
      level = CHFJPYLevels[lastCrossed(CHFJPY, CHFJPYLevels, price, false)];
      setLable(CHFJPY, level/100, (price - level)/100);
      
      
      level = JPYCHFLevels[lastCrossed(CHFJPY, JPYCHFLevels, price, true)];
      setLable("JPYCHF", level*100, (price - level)*100);
      
      
      level = USDCHFLevels[lastCrossed(USDCHF, USDCHFLevels, price, false)];
      setLable(USDCHF, level, price - level);
      
      
      level = CHFUSDLevels[lastCrossed(USDCHF, CHFUSDLevels, price, true)];
      setLable("CHFUSD", level, price - level);
      
      
      level = EURNZDLevels[lastCrossed(EURNZD, EURNZDLevels, price, false)];
      setLable(EURNZD, level, price - level);
      
      
      level = NZDEURLevels[lastCrossed(EURNZD, NZDEURLevels, price, true)];
      setLable("NZDEUR", level, price - level);
      
      
      level = EURGBPLevels[lastCrossed(EURGBP, EURGBPLevels, price, false)];
      setLable(EURGBP, level, price - level);
      
      
      level = GBPEURLevels[lastCrossed(EURGBP, GBPEURLevels, price, true)];
      setLable("GBPEUR", level, price - level);
      
      
      level = EURJPYLevels[lastCrossed(EURJPY, EURJPYLevels, price, false)];
      setLable(EURJPY, level/100, (price - level)/100);
      
      
      level = JPYEURLevels[lastCrossed(EURJPY, JPYEURLevels, price, true)];
      setLable("JPYEUR", level*100, (price - level)*100);
      
      
      level = EURUSDLevels[lastCrossed(EURUSD, EURUSDLevels, price, false)];
      setLable(EURUSD, level, price - level);
      
      
      level = USDEURLevels[lastCrossed(EURUSD, USDEURLevels, price, true)];
      setLable("USDEUR", level, price - level);
      
      
      level = GBPNZDLevels[lastCrossed(GBPNZD, GBPNZDLevels, price, false)];
      setLable(GBPNZD, level, price - level);
      
      
      level = NZDGBPLevels[lastCrossed(GBPNZD, NZDGBPLevels, price, true)];
      setLable("NZDGBP", level, price - level);
      
      
      level = GBPJPYLevels[lastCrossed(GBPJPY, GBPJPYLevels, price, false)];
      setLable(GBPJPY, level/100, (price - level)/100);
      
      
      level = JPYGBPLevels[lastCrossed(GBPJPY, JPYGBPLevels, price, true)];
      setLable("JPYGBP", level*100, (price - level)*100);
      
      
      level = GBPUSDLevels[lastCrossed(GBPUSD, GBPUSDLevels, price, false)];
      setLable(GBPUSD, level, price - level);
      
      
      level = USDGBPLevels[lastCrossed(GBPUSD, USDGBPLevels, price, true)];
      setLable("USDGBP", level, price - level);
      
      
      level = NZDJPYLevels[lastCrossed(NZDJPY, NZDJPYLevels, price, false)];
      setLable(NZDJPY, level/100, (price - level)/100);
      
      
      level = JPYNZDLevels[lastCrossed(NZDJPY, JPYNZDLevels, price, true)];
      setLable("JPYNZD", level*100, (price - level)*100);
      
      
      level = USDJPYLevels[lastCrossed(USDJPY, USDJPYLevels, price, false)];
      setLable(USDJPY, level/100, (price - level)/100);
      
      
      level = JPYUSDLevels[lastCrossed(USDJPY, JPYUSDLevels, price, true)];
      setLable("JPYUSD", level*100, (price - level)*100);
      
      
      level = NZDUSDLevels[lastCrossed(NZDUSD, NZDUSDLevels, price, false)];
      setLable(NZDUSD, level, price - level);
      
       
      level = USDNZDLevels[lastCrossed(NZDUSD, USDNZDLevels, price, true)];
      setLable("USDNZD", level, price - level);

   
   }
   
   
   
//+------------------------------------------------------------------+